<div id="header-wrap">
  <div id="header">
    <h1>Opquast Desktop</h1>
  </div>
</div>

<div id="main-wrap">
  <div id="main">
    <h2>About</h2>

    <h3>The Opquast Project</h3>

    <p><a href="http://www.opquast.com">Opquast</a> (Open Quality Standards) is an ecosystem aimed
    at improvement and rentability of websites.</p>

    <ul>
      <li>Checklists to understand and produce (<a
        href="http://checklists.opquast.com/fr/opquast-website">Opquast Website</a>, <a
        href="http://checklists.opquast.com/fr/opquastv2">Qualité Web</a>, <a
        href="http://checklists.opquast.com/fr/seo">SEO</a>, <a
        href="http://checklists.opquast.com/fr/opendata">Open data</a> checklists…)</li>
      <li>Testing tools to drive website quality
      (Opquast Desktop, <a href="http://reporting.opquast.com">Opquast reporting</a>)</li>
      <li>Professionnals to help you with your web projects
      (<a href="http://partners.opquast.com/">partners.opquast.com</a>)</li>
    </ul>

    <h3>Opquast Desktop</h3>

    <p>Opquast Desktop is an application that allows you to analyze your website using different
    quality or accessibility checklists.</p>

    <h2>Analyze a page</h2>

    <h3>Quick analysis</h3>

    <ul>
      <li>Press the toolbar button <img src="img/button.png" alt="Button screenshot" />
      to open the Opquast Desktop panel. This button can also be used to close the panel;</li>

      <li>If the current URI has already been analyzed, the application will show last analysis
      results;</li>

      <li>Otherwise, you will be offered to launch the analysis on the current page;</li>

      <li>To launch or relaunch, click on the appropriate button;</li>

      <li>The results will be directly visible on the panel;</li>

      <li>You can launch or relaunch the analysis at any time.</li>
    </ul>

    <p><strong>Note:</strong> You can also use "Opquast Desktop" menu in
    "Tools > Web developer" or the keyboard shortcut "ctrl + alt + o".</p>

    <h3>Result management</h3>

    <ul>
      <li>Search: type in the search box and results will be automatically filtered using your
      query.</li>

      <li>Filters: you can show results issued from only one of the available checklists or with a
      given status. Use the select boxes available in the result header row.</li>

      <li>Details: You can view a given result details by clicking on any line. For each test,
      Opquast Desktop provides you with a global comment and, when it’s relevant, a list of involved
      DOM nodes. The details window can be closed at any time by using the ESC key. You can show the
      previous or the next detail window using the appropriate links or the arrow keys of your
      keyboard.</li>

      <li>Export: the export button allows you to export your analysis  results to a CSV file or to
      Opquast Reporting.</li>
    </ul>

    <h2>Bug? Question? Please let us know</h2>

    <p>If you come across a bug, if you would like to propose an enhancement or if you would like to
    give us your impressions on the application, don't hesitate to <a
    href="https://reporting.opquast.com/projects/19559/issues/new">create a ticket on this
    project</a>.</p>

    <h2>Credits</h2>

    <h3>Version</h3>

    <p>You are using Opquast Desktop version {{! it.version }}.</p>

    <h3>Conception and development</h3>

    <p>Olivier Meunier, Elie Sloïm, Fabrice Bonny and Aurélien Levy for <a href=
    "http://www.temesis.com">Temesis SAS</a> - 18, rue Lucien Granet 33150 Cenon - France</p>

    <p>With the assistance of <em>pôle Aquitain en logiciels libres <a
    href="http://pole-aquinetic.fr/">Aquinetic</a></em> and with support from
    <em><a href="http://aquitaine.fr/">Région Aquitaine</a></em>.</p>

    <p>Many thanks to Temesis team and all Opquast Project contributors and partners.</p>

    <h2>Licenses</h2>

    <h3>Opquast Desktop Extension</h3>

    <p><a href="http://www.mozilla.org/MPL/">Mozilla Public Licence</a></p>

    <h3>Provides checklists</h3>

    <table>
      <caption>Checklists</caption>
      <thead>
        <tr>
          <th>Checklist</th>

          <th>Version</th>

          <th>License</th>
        </tr>
      </thead>

      <tbody>
        <tr>
          <td><a href="http://checklists.opquast.com/en/opquast-website">Opquast Website</a></td>
          <td>Version 1 (2013)</td>
          <td><a href="http://creativecommons.org/licenses/by-sa/2.0/fr/">Creative commons
          BY-SA</a></td>
        </tr>

        <tr>
          <td><a href="http://checklists.opquast.com/en/opquastv2">Opquast UX</a></td>
          <td>Version 2 (2010)</td>
          <td><a href="http://creativecommons.org/licenses/by-sa/2.0/fr/">Creative commons
          BY-SA</a></td>
        </tr>

        <tr>
          <td><a href="http://checklists.opquast.com/seo">Opquast SEO</a></td>
          <td>Version 1 (2011)</td>
          <td><a href="http://creativecommons.org/licenses/by-sa/2.0/fr/">Creative commons
          BY-SA</a></td>
        </tr>

        <tr>
          <td><a href="http://checklists.opquast.com/webperf">Opquast Webperf</a></td>
          <td>Version 1 (2012)</td>
          <td><a href="http://creativecommons.org/licenses/by-sa/2.0/fr/">Creative commons
          BY-SA</a></td>
        </tr>

        <tr>
          <td><a href="http://checklists.opquast.com/opendata">OpenData Dataset quality</a></td>
          <td>Version 1 (2013)</td>
          <td><a href="http://creativecommons.org/licenses/by-sa/2.0/fr/">Creative commons
          BY-SA</a></td>
        </tr>

        <tr>
          <td><a href="http://checklists.opquast.com/en/accessibilityfirststep">Opquast Accessibility
          First Step</a></td>
          <td>Version 1 (2012)</td>
          <td><a href="http://creativecommons.org/licenses/by-sa/2.0/fr/">Creative commons
          BY-SA</a></td>
        </tr>

        <tr>
          <td><a href="http://checklists.opquast.com/en/accessibilitysecondstep">Opquast Accessibility
          Second Step</a></td>
          <td>Version 1 (2012)</td>
          <td><a href="http://creativecommons.org/licenses/by-sa/2.0/fr/">Creative commons
          BY-SA</a></td>
        </tr>

        <tr>
          <td><a href="http://references.modernisation.gouv.fr/rgaa-accessibilite">RGAA (Référentiel
          Général d'accessibilité pour les administrations)</a></td>
          <td>Version 2.2.1 (2009)</td>
          <td><a href="http://references.modernisation.gouv.fr/rgaa-accessibilite">To be clarified</a></td>
        </tr>

        <tr>
          <td><a href=
          "http://www.accessiweb.org/index.php/accessiweb_2.1_liste_deployee.html">Accessiweb
          Liste déployée</a></td>
          <td>Version 2.1 (2009)</td>
          <td><a href=
          "http://www.accessiweb.org/fr/Label_Accessibilite/criteres_accessiweb/#conditions">Copyright
          © 2010 Association BrailleNet. Tous droits Réservés.</a></td>
        </tr>

        <tr>
          <td><a href=
          "http://www.accessiweb.org/index.php/accessiweb_2.1_liste_generale.html">Accessiweb
          Liste générale</a></td>
          <td>Version 2.1 (2009)</td>
          <td><a href=
          "http://www.accessiweb.org/fr/Label_Accessibilite/criteres_accessiweb/#conditions">Copyright
          © 2010 Association BrailleNet. Tous droits Réservés.</a></td>
        </tr>

        <tr>
          <td><a href="http://www.tresor.gouv.qc.ca/ressources-informationnelles/standards-sur-laccessibilite-du-web/">SGQRI</a></td>
          <td>Version 1.0 (2012)</td>
          <td>See document</td>
        </tr>
      </tbody>
    </table>

    <h3>Other embeded softwares</h3>

    <ul>
      <li><a href="http://jquery.com/">jQuery</a></li>
      <li><a href="http://glazman.org/JSCSSP/">JSCSSP</a></li>
      <li><a href="http://olado.github.com/doT/">doT.js</a></li>
    </ul>
  </div>
</div>

<div id="footer-wrap">
  <div id="footer">
    <ul id="logos">
      <li><a href="http://pole-aquinetic.fr/"><img src="img/aquinetic.png" alt="Aquinetic" /></a></li>
      <li><a href="http://www.opquast.com/"><img src="img/opquast.png" alt="Opquast" /></a></li>
      <li><a href="http://aquitaine.fr/"><img src="img/aquitaine.png" alt="Région Aquitaine" /></a></li>
    </ul>
    <p><a href="https://reporting.opquast.com/">Opquast</a> is a project of <a href=
    "http://temesis.com/">Temesis ©</a></p>
  </div>
</div>
